from cStringIO import StringIO
import os.path
import configobj
from validate import Validator
import globalVars
from logHandler import log
from locale import getdefaultlocale

JGT_CONFIG_FILENAME = "JGT.ini"
# get a language of the OS localization.
lo_lang = getdefaultlocale()
# get the first element of the tuplet.
s = lo_lang[0]
# get the default language which is translated into.
if s == "zh_HK":
	lo_lang = "zh-TW"
elif s.startswith("zh"):
	lo_lang = s.replace('_', '-')
else:
	lo_lang = s[0:s.find("_")]

JGTConfig = None

_configSpec = """
[translation]
from = string(default=ja)
into = string(default=en)
[settings]
copytranslatedtext = boolean(default=true)
username = string(default="")
"""

def load():
	global JGTConfig
	if JGTConfig is None:
		path = os.path.join(globalVars.appArgs.configPath, JGT_CONFIG_FILENAME)
		JGTConfig = configobj.ConfigObj(path, configspec=StringIO(_configSpec.format(lo_lang=lo_lang)), encoding="utf-8")
		JGTConfig.newlines = "\r\n"
		JGTConfig.stringify = True
		val = Validator()
		ret = JGTConfig.validate(val, preserve_errors=True, copy=True)
		if ret != True:
			log.warning("JGT configuration is invalid: %s", ret)

def save():
	global JGTConfig
	if JGTConfig is None:
		raise RuntimeError("JGT config is not loaded.")
	val = Validator()
	JGTConfig.validate(val, copy=True)
	JGTConfig.write()
