#interface.py
# Copyright (C) 2012-2014 Aleksey Sadovoy AKA Lex <lex@progger.ru>,
#ruslan <ru2020slan@yandex.ru>,
#beqa <beqaprogger@gmail.com>
#other nvda contributors
#This file is covered by the GNU General Public License.
#See the file COPYING for more details.

import os.path
import wx
import gui
from langslist import langslist
import langslist as lngModule
import globalVars
import config
import _config
import addonHandler
from copy import deepcopy

_config.load()
addonHandler.initTranslation()

class JGTSettingsDialog(gui.SettingsDialog):
	# Translators: name of the dialog.
	title = _("Japanese Games Translator Settings")

	def __init__(self, parent):
		super(JGTSettingsDialog, self).__init__(parent)

	def makeSettings(self, sizer):
		# Translators: Help message for a dialog.
		helpLabel = wx.StaticText(self, label=_("Select translation source and target language:"))
		helpLabel.Wrap(self.GetSize()[0])
		sizer.Add(helpLabel)
		fromSizer = wx.BoxSizer(wx.HORIZONTAL)
		# Translators: A setting in addon settings dialog.
		fromLabel = wx.StaticText(self, label=_("Source language:"))
		fromSizer.Add(fromLabel)
		self._fromChoice = wx.Choice(self, choices=["ja"])
		fromSizer.Add(self._fromChoice)
		intoSizer = wx.BoxSizer(wx.HORIZONTAL)
		# Translators: A setting in addon settings dialog.
		intoLabel = wx.StaticText(self, label=_("Target language:"))
		intoSizer.Add(intoLabel)
		self._intoChoice = wx.Choice(self, choices=["en"])
		intoSizer.Add(self._intoChoice)
		sizer.Add(fromSizer)
		sizer.Add(intoSizer)
		# Translators: A setting in addon settings dialog.
		self.copyTranslationChk = wx.CheckBox(self, label=_("Copy translation result to clipboard"))
		self.copyTranslationChk.SetValue(_config.JGTConfig['settings']['copytranslatedtext'])
		sizer.Add(self.copyTranslationChk)
		#ian need to fix this if we ever have more languages that you can translate to.
		#iLang_from = self._fromChoice.FindString(self.getDictKey(_config.JGTConfig['translation']['from']))
		#iLang_to = self._intoChoice.FindString(self.getDictKey(_config.JGTConfig['translation']['into']))
		#self._fromChoice.Select(iLang_from)
		#self._intoChoice.Select(iLang_to)
		# need to select them even though they are the only choices, because by default the combo box has no items selected.
		iLang_from = self._fromChoice.FindString("ja")
		iLang_to = self._intoChoice.FindString("en")
		self._fromChoice.Select(iLang_from)
		self._intoChoice.Select(iLang_to)

	def postInit(self):
		self._fromChoice.SetFocus()

	def onOk(self, event):
		super(JGTSettingsDialog, self).onOk(event)
		# Update Configuration
		_config.JGTConfig['translation']['from'] = self._fromChoice.GetStringSelection()
		_config.JGTConfig['translation']['into'] = self._intoChoice.GetStringSelection()
		#_config.JGTConfig['translation']['from'] = langslist[self._fromChoice.GetStringSelection()]
		#_config.JGTConfig['translation']['into'] = langslist[self._intoChoice.GetStringSelection()]
		_config.JGTConfig['settings']['copytranslatedtext'] = self.copyTranslationChk.GetValue()
		_config.save()
