import speech
import api
import queueHandler
import threading
import tones
from tones import beep
import datetime

JGT_oldSpeak = speech.speakText
JGT_data=""
JGT_autoLastSpoken=False
JGT_autoClipboard = False
JGT_globalPlugin=None
JGT_LastTranslateTime = datetime.datetime.now()

lastSpokenInGame = False
def JGT_speak(text, *args, **kwargs):
	global JGT_data, JGT_oldSpeak, JGT_autoLastSpoken, JGT_globalPlugin, lastSpokenInGame, JGT_LastTranslateTime
	lastText = JGT_data
	JGT_data = text
	shouldSpeak = True
	if JGT_autoLastSpoken:
		if getInGame():
			if not lastSpokenInGame:
				lastSpokenInGame = True # this helps us avoid auto translating the title when they first switch into the game.
			else:
				# if this is the same text as before, and coming through faster than a user could press a key combo to repeat it, then it is probably someone using ClipReader with JGT.
				elapsed = (datetime.datetime.now() - JGT_LastTranslateTime).total_seconds()
				if not (text == lastText and elapsed < .05):
					(shouldTranslate, shouldSpeak) = getShouldTranslate(text)
					if shouldTranslate:
						JGT_LastTranslateTime = datetime.datetime.now()
						#beep(500, 50)
						threading.Thread(target=JGT_globalPlugin.translate, args=(text,)).start()
	if shouldSpeak:
		JGT_oldSpeak(text, *args, **kwargs)

def is_ascii(s):
	return all(ord(c) < 256 for c in s)

def queueMessage(text):
	global JGT_oldSpeak
	queueHandler.queueFunction(queueHandler.eventQueue, JGT_oldSpeak, text)

def getShouldTranslate(text): # returns a boolean indicating if it should translate, and another indicating if we should speak the untranslated text.
	# returns (shouldTranslate, shouldSpeak)
	if not text or not isinstance(text,basestring) or text.isspace():
		return (False, True)
	# code for getting the title came from globalCommands.py in the NVDA source code.
	obj=api.getForegroundObject()
	title=obj.name
	if title == None:
		title = "" # making it an empty string saves us headaches later, like when we check its length.
	validGame = getInGame()
	if validGame and title == text:
		return (False, False) # we do not speak or translate the title when in a game because it is sometimes the entire menu.
	if validGame and not is_ascii(text) and not text.endswith(_("selected")) and not text.startswith(_("selected")):
		return (True, False)
	return (False, True)

def getInGame():
	# returns a boolean
	obj=api.getForegroundObject()
	wcn = obj.windowClassName
	appName = obj.appModule.appName
	valid = wcn == "hspwnd0" or wcn == "oniwnd0" or appName == "play" or appName == "brave of cloudia"
	valid = valid or (wcn == "SDL_app" and appName == "ruby")
	return valid

def ianDebug():
	queueMessage(str(getInGame()))
	#obj=api.getForegroundObject()
	#title=obj.name
	#if title == None:
	#	title = "" # making it an empty string saves us headaches later, like when we check its length.
	#queueMessage(title)
