import ui
from logHandler import log
import os.path
import wx
import gui
from langslist import langslist
import langslist as lngModule
import globalVars
import config
import _config
import addonHandler
from copy import deepcopy

import sys
impPath = os.path.abspath(os.path.dirname(__file__))
sys.path.append(impPath)
import urllib2
import json
del sys.path[-1]

_config.load()

class JGTLoginDialog(gui.SettingsDialog):
	# Translators: name of the dialog.
	title = _("Login to the JGT service")

	def __init__(self, parent, sessionHolder):
		super(JGTLoginDialog, self).__init__(parent)
		self.sessionHolder = sessionHolder

	def makeSettings(self, sizer):
		# Translators: Help message for a dialog.
		helpLabel = wx.StaticText(self, label=_("Enter your username and password for JGT:"))
		helpLabel.Wrap(self.GetSize()[0])
		sizer.Add(helpLabel)
		userSizer = wx.BoxSizer(wx.HORIZONTAL)
		# Translators: A setting in addon settings dialog.
		userLabel = wx.StaticText(self, label=_("Username:"))
		userSizer.Add(userLabel)
		self._userText = wx.TextCtrl(self)
		self._userText.SetValue(_config.JGTConfig['settings']['username'])
		userSizer.Add(self._userText)
		passSizer = wx.BoxSizer(wx.HORIZONTAL)
		# Translators: A setting in addon settings dialog.
		passLabel = wx.StaticText(self, label=_("Password:"))
		passSizer.Add(passLabel)
		self._passText = wx.TextCtrl(self, style=wx.TE_PASSWORD)
		passSizer.Add(self._passText)
		sizer.Add(userSizer)
		sizer.Add(passSizer)

	def postInit(self):
		self._userText.SetFocus()

	def onOk(self, event):
		super(JGTLoginDialog, self).onOk(event)
		# attempt to login
		user = self._userText.GetValue()
		_config.JGTConfig['settings']['username'] = user
		_config.save()
		# pass is a python keyword so we had to rename this variable
		password = self._passText.GetValue()
		# build the request url
		urlTemplate = 'https://BlindGamers.com/api/login1?u={user}&p={password}'
		#urlTemplate = 'http://localhost:15678/api/login1?u={user}&p={password}'
		user = urllib2.quote(user)
		password = urllib2.quote(password)
		url = urlTemplate.format(user=user, password=password)
		try:
			data = json.load(urllib2.urlopen(url))
			error = data[0]
			if error != "":
				gui.messageBox(error,_("Error"),style=wx.OK | wx.ICON_ERROR)
			self.sessionHolder.sessionID = data[1]
		except Exception as e:
			# get the message from the exception
			msg = str(e)
			gui.messageBox(msg, _("Error"),style=wx.OK | wx.ICON_ERROR)
