# encoding: utf-8
#
# Copyright (C) 2013 Mesar Hameed <mhameed@src.gnome.org>
# This file is covered by the GNU General Public License.
# See the file COPYING for more details.

import json
import gui
import os
import re
import sys
import threading
from time import sleep
from random import randint
from logHandler import log
import ui
import jgt_shared

impPath = os.path.abspath(os.path.dirname(__file__))
sys.path.append(impPath)
import urllib2
import urllib3
del sys.path[-1]

# global connection pool manager
connPool = urllib3.PoolManager(10)

class Translator(threading.Thread):

	def __init__(self, lang_from, lang_to, text, sessionID, appTitle, *args, **kwargs):
		super(Translator, self).__init__(*args, **kwargs)
		self._stop = threading.Event()
		self.text = text
		self.lang_to = lang_to
		self.lang_from = lang_from
		self.sessionID = sessionID
		self.appTitle = appTitle
		self.translation = ''

	def stop(self):
		self._stop.set()

	def run(self):
		global connPool
		text = self.text.encode('utf-8')
		text = urllib2.quote(text)
		appTitle = self.appTitle.encode('utf-8')
		appTitle = urllib2.quote(appTitle)
		# using http instead of https gets rid of the long connection initiation times, and using the connection pool allows us to use persistent connections which gives great performance benefits.
		#urlTemplate = 'https://BlindGamers.com/api/translate1?sl={lang_from}&tl={lang_to}&t={text}&app={app}&sid={sessionID}'
		urlTemplate = 'http://BlindAudioGames.com/api/translate1?sl={lang_from}&tl={lang_to}&t={text}&app={app}&sid={sessionID}'
		#urlTemplate = 'http://localhost:15678/api/translate1?sl={lang_from}&tl={lang_to}&t={text}&app={app}&sid={sessionID}'
		url = urlTemplate.format(lang_from=self.lang_from, lang_to=self.lang_to, text=text, sessionID=self.sessionID, app=appTitle)
		#jgt_shared.queueMessage(url)
		translation = ""
		try:
			r = connPool.request('GET', url)
			data = json.loads(r.data)
			#data = json.load(urllib2.urlopen(url))
			translation = data[0]
			loggedIn = data[1]
			if not loggedIn:
				jgt_shared.queueMessage("Your session has expired, please login again using the JGT login dialog in preferences")
		except Exception as e:
			#gui.messageBox(str(e))
			jgt_shared.queueMessage(str(e))
		self.translation = translation
